#include "pacman.h"

main(argc, argv)
int argc;
char **argv;
{
static int socket;
USER users[MAXUSERS];
GAME pcrunch, *g_ptr = &pcrunch;
int (*ssleep)(unsigned long) = usleep();
FILE *gameruleset, *lytruleset, *mapruleset, *physruleset, *infofile;
FILE *fopen();

lytruleset = fopen("~/pcrunch/local/layout.rules", "r");
mapruleset = fopen("~/pcrunch/shared/map.rules", "r");
physruleset = fopen("~/pcrunch/shared/physics.rules", "r");
gameruleset = fopen("~/pcrunch/shared/game.rules", "r");
infofile = fopen("~/pcrunch/shared/info", "r");
get_rules(gameruleset, lytruleset, mapruleset, physruleset, g_ptr);

dslurp(infofile, '!');
get_initial_data(g_ptr, infofile);

if(g_ptr->port == 0)
  g_ptr->port = PORT;
set_up_connection(g_ptr->port);

first_get_packet(g_ptr, head);
talk(g_ptr, head);

for(; display(g_ptr); *ssleep(pacman.delay))
  b_pac(g_ptr, head, lytruleset, mapruleset);

}

/* @@@@@@@@
 @@  *  *  @
 *@   /\   @
 *@   \/   @
 * @@@@@@@@
 *
 * That bird's as surprised as you.
 */