move_player(player, direction, map)
USER *player;
char direction;
char **map;
{
char x, y;

x = player->location.x;
y = player->location.y;
switch(player->direction)
  {
  case up:
    if(movetest(x, y - 1, map))    
      --(player->location.y);
    break;
  case down:
    if(movetest(x, y + 1, map))
      ++(player->location.y);
    break;
  case left:
    if(movetest(x - 1, y, map))
      --(player->location.x);
    break;
  case right:
    if(movetest(x + 1, y, map))
      ++(player->location.x);
    break;
  default:
    fprintf(stderr, "ERROR: direction unknown!")
    break;
  }

}


movetest(x, y, map)
char x, y, **map;
{
if(iswall(map[x][y]))
  return 0;
else 
  return 1;
}
  
map_move(all_users, player, map, circuit)
USER *player, *all_users;
char map[40][20];
CIRCUIT *circuit;
{
char x = player->x, y = player->y;
USER *neighbor;

if(isdot(map[x][y]))
  ++(player->dot_cnt);
else if(ispwrpellet(map[x][y]))
  player->status |= POWERFUL;
else if(iswire(map[x][y]))
  player->wire_cnt += 5;
else if(isnear_competitor(map[x][y]))
  {
  neighbor = nearest(all_users, map);
  if(neighbor->rank < player->rank)
    {
    neighbor->status = BOUGHT;
    neighbor->owner = player->id;
    }
  }
else if(israwpower(map[x][y]))
  player->status = DEAD;
else if(ishole(map[x][y]))
  player->status = DEAD;
else if(isswitch(map[x][y]))
  {
  int n;
  n = switch_num(x, y);
  circuit[n]->switch = !(circuit[n]->switch);
  }
else if(isitem(map[x][y]))
  {
  if(isdietpill(map[x][y]))
    player->items[last_elem(player->items, 5)] = DIET_PILL;
  else if(istar(map[x][y]))
    player->items[last_elem(player->items, 5)] = TAR;
  else if(ishovershoes(map[x][y]))
    player->items[last_elem(player->items, 5)] = H_SHOES;
  else if(issocket(map[x][y]))
    player->items[last_elem(player->items, 5)] = SOCKET;
  }
map[x][y] = player->id | PLAYER;
}

int last_elem(array, n)
int *array;
int n;
{
int i;

for(i = 0; i < n; ++i)
  if(array[i] == NULL)
    return(i);
return(-1);
}
