#include "randcrypt.h"

main(argc, argv, env)
int argc;
char *env[];
char *argv[];
{
long seed;
char type;
char filename[FNAME_LEN], outfilename[FNAME_LEN];
FILE *fileptr, *outptr, *g_fopen();

sscanf(argv[SEED_ARG_POS], "%d", &seed);
strcpy(filename, argv[INFILE_ARG_POS]);
strcpy(outfilename, argv[OUTFILE_ARG_POS]);
if(filename == NULL)
  fileptr = stdin;
else
  fileptr = g_fopen(filename, "r");
if(outfilename == NULL)
  outptr = stdout;
else
  outptr = g_fopen(outfilename, "w");

type = determine_type(argv[0], argv[1]);
switch((int)type)
{
  case ENCRYPT: encrypt(fileptr, outptr, seed);			break;
  case DECRYPT: decrypt(fileptr, outptr, seed);			break;
  case DETERMINATIVE_ENCRYPT: d_encrypt(fileptr, outptr);	break;
  default: error_type(TYPE_ERROR);				break;
}
exit(0);
}
