#include "pcrunch.h"

int wire_on(struct position location, short map[40][20])
{
short x, y;

x = location.x;
y = location.y;

if(typeof(map[x][y]) == V_WIRE_OFF)
  if(t_is_north(location, V_WIRE_ON) || t_is_south(location, V_WIRE_ON))
    w_activate(location, map);
else if(typeof(map[x][y]) == H_WIRE_OFF) 
       if(t_is_east(location, H_WIRE_ON) || t_is_west(location, H_WIRE_ON))
          w_activate(location, map);
return(0);
}

void w_activate(struct position location, short map[40][20])
{
short x, y;
x = location.x;
y = location.y;
struct wire *wptr;

wptr = wire_find(idof(map[x][y]));
wptr->on = 1;
}

struct wire *wire_find(unsigned char ident)
{
/* Given that wire_array is an external array of struct wire */
/* and MAX_WIRES == the number of elements in wire_array */
struct wire *wptr;

for(i = 0; i < MAX_WIRES; ++i)
  if(wire_array[i].id == ident)
    {
    wptr = wire_array[i];
    return(wptr);
    }
}