#include "randcrypt.h"

void d_encrypt(fileptr, outptr, stringency)
FILE *fileptr, *outptr;
char stringency;
{
int firstchar;
long seed;

firstchar = getc(fileptr);
for(seed = baseseed(firstchar, stringency); seedtest(seed, stringency, fileptr); seed += stringency)
  ;
fprintf(outptr, "\n%d", seed);
encrypt(fileptr, outptr, seed);
}

baseseed(firstchar, stringency)
int firstchar;
char stringency;
{
int offset;
long seed = 0;

creset();
for(offset = BYTE - firstchar; (seed = c_random()) != offset; initcseed(seed++))
  ;
return(seed);
}

seedtest(seed, stringency, fileptr)
char stringency;
long seed;
FILE *fileptr;
{
register int c;

rewind(fileptr);
creset();
for(initcseed(seed); ((c = getc(fileptr)) + (c_random())) >= stringency && c != EOF;)
  ;  
if(c != EOF)
  return(1);
else
  return(0);
}
