/* Minix version */
/* The necessary "include" files */
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>

/* Various useful symbolic constants */
  /* Usage types */
#define ENCRYPT 'e'
#define DECRYPT 'd'
#define DETERMINATIVE_ENCRYPT 'c'
  /* Usage arguments */
#define ENCRYPT_ARG 'e'
#define DECRYPT_ARG 'd'
#define DETERMINATIVE_ENCRYPT_ARG 's'
  /* OS dependant constants */
#define FLAG '-'
#define BYTE 256
#define FNAME_LEN 14
  /* Error numbers */
#define MISC_ERROR 0
#define USAGE_ERROR 1
#define TYPE_ERROR 2
  /* Positions of arguments in argv[] */
#define SEED_ARG_POS 2
#define INFILE_ARG_POS 3
#define OUTFILE_ARG_POS 4

/* Function declarations */
char dettype();
int random();
void encrypt();
long c_random();
void initcseed();
void creset();
void decrypt();
void d_encrypt();
int baseseed();
int seedtest();
